/*
 * Exported DPF interface.
 */
#ifndef __OLD_DPF_H__
#define __OLD_DPF_H__

#if 0
/* error codes */
enum {
        DPF_SUCCESS = 1,
        DPF_INVALIDPID = -1,
        DPF_FILTER_OVERLAP = -2,
};
#endif


/* DPF ops. */
enum {
        DPF_NIL,
        /* nulary operators */
#       define DPF_NULARY_P(x) ((x) >= DPF_SHIFTI && (x) <= DPF_BITS32I)
        DPF_SHIFTI,
#       define DPF_BITS_P(x) ((x) >= DPF_BITS8I && (x) <= DPF_BITS32)
        DPF_BITS8I,
        DPF_BITS16I,
        DPF_BITS32I,
        /* unary operators (and operators with constant right operands) */
#       define DPF_UNARY_P(x) ((x) >= DPF_SHIFT && (x) <= DPF_BITS32)
        DPF_BITS8,
        DPF_BITS16,
        DPF_BITS32,
        DPF_SHIFT,
        DPF_EQI,
        DPF_NEI,
        DPF_ANDI,
        DPF_ORI,
        /* binary operators */
#       define DPF_BINARY_P(x) ((x) >= DPF_EQ && (x) <= DPF_OR)
        DPF_EQ,
        DPF_NE,
        DPF_AND,
        DPF_OR,
        /* n-ary operators */
        DPF_DEQ,                /* disjunction (hash table of values) */
        DPF_OROR,
        /* some ops used by the code generator */
        DPF_IMM,
        DPF_NOTHING,
        DPF_LAST
};

/* 
 * Swizzled filter form.  Generated by preprocessor.  
 */
struct dpf_frozen_ir {
        unsigned char   op,     /* the operator */
                        len;    /* length of conjunction or shift */
        signed char     r0,     /* kid numbers that we depend on (if any). */
                        r1;
        unsigned        imm;    /* immediate value (if any) */
};

int (*dpf_iptr)(unsigned char *msg, unsigned nbytes);

#endif /* __OLD_DPF_H__ */
