        /*
         * Create filter to check that the 8th byte in msg is 16 and
         * the short at offset 10 is 0x1234.
         */
        #include <dpf.h>
        #include <demand.h>
        int main(void) {
                struct dpf_ir filter;  /* struct to hold filter. */
                uint8 msg[128];
                int pid, res;

                dpf_init(&filter);  /* must be done before use */
                dpf_eq8(&filter, 8, 16);
                dpf_eq16(&filter, 10, 0x1234);

                /* insert filter */
                if((pid = dpf_insert(&filter)) < 0)
                        fatal(Insertion failed);

                /* print out disassembled code. */
                dpf_output();

                /* create message */
                *(uint8 *) ((uint8 *)msg + 8) = 16;
                *(uint16 *) ((uint8 *)msg + 10) = 0x1234;

                /* test it */
                if((res = dpf_iptr(msg, sizeof msg)) != pid) {
                        printf("pid  = %d, res = %d\n", pid, res );
                        fatal(bogus classification);
                }

                /* delete filter */
                if(dpf_delete(pid) < 0)
                        fatal(Delete failed);

                return 0;
        }


